// ListColumnPickerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TPMSDataViewer.h"
#include "ListColumnPickerDlg.h"


// CListColumnPickerDlg dialog

IMPLEMENT_DYNAMIC(CListColumnPickerDlg, CDialogEx)

CListColumnPickerDlg::CListColumnPickerDlg(CWnd* pParent, CListCtrl_Column_Picker* listCtrl)
	: CDialogEx(CListColumnPickerDlg::IDD, pParent)
{

	m_pListCtrl = listCtrl;
}

CListColumnPickerDlg::~CListColumnPickerDlg()
{
}

void CListColumnPickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CListColumnPickerDlg, CDialogEx)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CListColumnPickerDlg message handlers

BOOL CListColumnPickerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog(); 

	CRect rect(CPoint(10, 10), CSize(300, 20)); 
 
	// Ʈ  Ե  ʵ带 üũ ư ߰
	m_arButtons.SetSize(m_pListCtrl->GetColumnStateCount());
	for( int i = 0 ; i < m_pListCtrl->GetColumnStateCount(); i++) {
		// Retrieve column-title
		LVCOLUMN lvc = {0};
		lvc.mask = LVCF_TEXT;
		TCHAR sColText[256];
		lvc.pszText = sColText; 
		lvc.cchTextMax = sizeof(sColText)-1;
		VERIFY( m_pListCtrl->GetColumn(i, &lvc) );

		if (m_arButtons[i].Create(lvc.pszText, WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_AUTOCHECKBOX | BS_NOTIFY, rect, this, i + 100) == FALSE) {
			ASSERT(FALSE);
		}
		m_arButtons[i].ModifyStyleEx(WS_EX_NOPARENTNOTIFY, 0);
		m_arButtons[i].SetCheck(m_pListCtrl->IsColumnVisible(i) ? TRUE : FALSE);
		rect.OffsetRect(0, 25);
	}

	rect.top = 0;
	rect.left = 0;
	rect.right += 10;
	rect.bottom += 10;

	MoveWindow(&rect, FALSE);
	CenterWindow(AfxGetMainWnd());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CListColumnPickerDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	m_arButtons.RemoveAll();
}

BOOL CListColumnPickerDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// ư ŬǾ 
	if (HIWORD(wParam) == BN_CLICKED) {
		UINT nID = LOWORD(wParam);
		int nCount = m_arButtons.GetCount();
		for (int i = 0; i < nCount; i++) {
			if (nID == m_arButtons[i].GetDlgCtrlID()) {
				// ư üũǾ  show, ׷  hide 
				m_pListCtrl->ShowColumn(i, !m_pListCtrl->IsColumnVisible(i));
				break;
			}
		}
	}

	return CDialogEx::OnCommand(wParam, lParam);
}
